﻿using System.Collections.Generic;
using Gumini.JulaDB.DataTypes;

namespace Gumini.JulaDB.Expressions
{
    /// <summary>
    /// Represents the '*' symbol which is a valid part of some expressions, e.g. count(*).
    /// </summary>
    internal class Asterisk : Expression
    {
        public override TypedValue Evaluate(List<Context<TypedValue>> context)
        {
            return TypedValue.Asterisk;
        }

        public override DataType InferType(Context<DataType> context)
        {
            // asterisk has no data type
            return null;
        }

        public override bool Equals(Expression other)
        {
            var b = other as Asterisk;
            return (b != null);
        }

        public override string ToString()
        {
            return "*";
        }
    }
}
