﻿using System.Collections.Generic;
using System.Linq;
using Gumini.JulaDB.DataTypes;

namespace Gumini.JulaDB.Expressions.Functions
{
    /// <summary>
    /// Converts string to lowercase.
    /// </summary>
    internal class LowerFunction : ScalarFunction
    {
        public LowerFunction()
            : base("lower", 1) { }

        public override object Evaluate(IEnumerable<object> args)
        {
            string arg = (string)DataType.Varchar.ConvertFrom(args.Single());
            return arg.ToLowerInvariant();
        }

        public override DataType GetReturnType()
        {
            return DataType.Varchar;
        }
    }
}
