﻿using System.Collections.Generic;
using System.Linq;
using Gumini.JulaDB.DataTypes;

namespace Gumini.JulaDB.Expressions.Functions
{
    /// <summary>
    /// Converts string to uppercase.
    /// </summary>
    internal class UpperFunction : ScalarFunction
    {
        public UpperFunction()
            : base("upper", 1) { }

        public override DataType GetReturnType()
        {
            return DataType.Varchar;
        }

        public override object Evaluate(IEnumerable<object> args)
        {
            string arg = (string)DataType.Varchar.ConvertFrom(args.Single());
            return arg.ToUpperInvariant();
        }
    }
}
