﻿using System;

namespace Gumini.JulaDB.Expressions.Operators
{
    internal class AndOperator : LogicalOperator
    {
        public AndOperator()
            : base("and") { }

        protected override bool? EvaluateCore(bool? a, bool? b)
        {
            // "If numeric values are assigned to FALSE, UNKNOWN and TRUE such that FALSE is less than UNKNOWN and UNKNOWN is less than TRUE,
            // then A AND B AND C... = MIN(A, B, C ...) and A OR B OR C ... = MAX(A, B, C...)."
            return IntegerToBool(
                Math.Min(BoolToInteger(a), BoolToInteger(b)));
        }
    }
}
