﻿using System.Collections.Generic;
using Gumini.JulaDB.DataTypes;

namespace Gumini.JulaDB.Interfaces
{
    public interface IColumn
    {
        /// <summary>
        /// The default name of the column, e.g. 'name'.
        /// </summary>
        string ColumnName { get; }

        /// <summary>
        /// Type of data stored in the column.
        /// </summary>
        DataType Type { get; }

        /// <summary>
        /// All of the names that might refer to this particular column, e.g. 'name', 'person.name', 'p.name'.
        /// </summary>
        IEnumerable<string> AllNames { get; }
    }
}
